﻿using System;
using System.Collections.Generic;
using System.Text;
using Editor.Document;
using Editor.Document.UseCase;
using Editor.Numbering;

namespace Editor.Commands.Document.UseCase
{
    public sealed class AddMainFlow : ICommand, IDocumentCommand
    {
        private UseCaseDocument document;

        public IDocument Document
        {
            get { return document as IDocument; }
        }

        public AddMainFlow( UseCaseDocument document )
        {
            this.document = document;
        }

        public bool Execute()
        {
            int sectionRow = document.FindSection( ESectionType.MainFlow );

            if( sectionRow == -1 ) return false;

            TemplateRow mainFlowSection = document[sectionRow] as TemplateRow;

            mainFlowSection.Add( new MainFlow( new DefaultNumbering("M"), "New Main Flow" ) );

            return true;
        }
    }
}
