﻿using System;
using System.Collections.Generic;
using System.Text;
using Editor.Document;
using Editor.Text.UseCase;
using Editor.Document.UseCase;

namespace Editor.Commands.Document.UseCase
{
    public sealed class DeleteActor : ICommand, IDocumentCommand
    {
        private ActorGlyph actorGlyph;
        private UseCaseDocument document;

        public IDocument Document
        {
            get { return document as IDocument; }
        }

        public DeleteActor( UseCaseDocument document, ActorGlyph actorGlyph )
        {
            this.actorGlyph = actorGlyph;
            this.document = document;
        }

        public bool Execute()
        {
            for( int i1 = 0; i1 < document.RowCount; i1++ )
            {
                if( document[i1] is Actors )
                {
                    Actors actors = document[i1] as Actors;
                    ActorGlyph tempGlyph;

                    for( int i2 = 0; i2 < actors.Text.VirtualLength; i2++ )
                    {
                        tempGlyph = actors.Text[i2] as ActorGlyph;

                        if( object.ReferenceEquals( actorGlyph, tempGlyph ) )
                        {
                            if( i2 == 0 ) 
                            {
                                if( actors.Text.VirtualLength >= 3 ) actors.Text.Remove( 0, 3 );
                                else actors.Text.Remove( 0, 1 );
                            }
                            else actors.Text.Remove( i2 - 3, 3 );

                            return true;
                        }
                    }
                }
            }

            return false;
        }
    }
}
