﻿using System;

namespace Editor.Numbering
{
    public interface INumbering : ICloneable<INumbering>, IComparable<INumbering>, IChangeHandler
    {
        string Label { get; set; }
        int Level { get; }
        string LongestNumber { get; }

        void Copy( INumbering other, int level );
        bool Decrease( short difference );
        bool DecreaseLevel();
        bool Increase( short difference );
        bool IncreaseLevel();
        INumbering NextNumber();
        INumbering PreviousNumber();
        void Reset();
    }
}
