﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Editor.Numbering
{
    public sealed class ShortNumber : INumber, ICloneable<ShortNumber>
    {
        private short number;

        public string Current
        {
            get { return number.ToString(); }
        }

        public string Longest
        {
            get 
            {
                short longestNumber = 99;
                return longestNumber.ToString(); 
            }
        }

        internal short Value
        {
            get { return number; }
            set { number = value; }
        }

        public ShortNumber()
        {
            number = 1;
        }

        public ShortNumber Clone()
        {
            ShortNumber clone = new ShortNumber();
            clone.Value = number;

            return clone;
        }

        public int CompareTo( INumber other )
        {
            if( other == null ) return 1;

            if( other is ShortNumber )
                return number.CompareTo( ((ShortNumber)other).Value );
            else return string.Compare( this.ToString(), other.ToString() );
        }

        public bool Decrease( short difference )
        {

            if( ( difference > 0 ) && ( number > difference ) ) 
            {
                number -= difference;
                return true;
            }
            return false;
        }

        public bool Increase( short difference )
        {
            if( ( difference > 0 ) && ( number + difference <= 99 ) ) 
            {
                number += difference;
                return true;
            }
            
            return false;
        }
    }
}
