﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.ComponentModel;
using Editor.Collections;

namespace Editor.Project
{
    public sealed class Actor : TreeNode, IProjectItem
    {
        private EventArgs changeArgs;
        private string description;
        private string goals;
        private bool objectChanging;
        private UseCaseModel model;
        private bool saved;
        private BindingList<Variation> variations;

        public IProjectItem this[int index]
        {
            get { throw new NotImplementedException(); }
        }

        public bool Composite
        {
            get { return false; }
        }

        public bool Changing
        {
            get { return objectChanging; }
        }

        public string Description
        { 
            get { return description; }
            set { description = value; }
        }

        public string Goals
        { 
            get { return goals; }
            set { goals = value; }
        }

        public int ItemCount
        {
            get { throw new NotImplementedException(); }
        }

        public string ItemName
        {
            get { return Text; }
            set 
            { 
                Text = value;

                ObjectChangedEvent( this, EventArgs.Empty );
            }
        }

        public IProjectItem ParentItem
        {
            get { return model as IProjectItem; }
        }

        public bool Saved
        {
            get { return saved; }
            set
            {
                saved &= value;
            }
        }

        public BindingList<Variation> Variations
        {
            get { return variations; }
            set 
            {
                variations = value;

                ObjectChangedEvent( this, EventArgs.Empty );
            }
        }

        public event EventHandler ObjectChanged;
        public event EventHandler ObjectChanging;

        public Actor( string name, UseCaseModel model )
        {
            changeArgs = null;
            ImageIndex = 2;
            objectChanging = false;
            this.model = model;
            saved = false;
            SelectedImageIndex = 2;
            Text = name;
            variations = new BindingList<Variation>();
  
            variations.Add( new Variation( string.Empty ) );
            variations.Add( new Variation( string.Empty ) );
            variations.Add( new Variation( string.Empty ) );
            variations.Add( new Variation( string.Empty ) );
            variations.Add( new Variation( string.Empty ) );
            variations.Add( new Variation( string.Empty ) );
            variations.Add( new Variation( string.Empty ) );
            variations.Add( new Variation( string.Empty ) );
            variations.Add( new Variation( string.Empty ) );
            variations.Add( new Variation( string.Empty ) );
            variations.Add( new Variation( string.Empty ) );
            variations.Add( new Variation( string.Empty ) );
        }

        public void Add( IProjectItem item )
        {
            throw new NotImplementedException();
        }

        public void BeginChange()
        {
            if( !objectChanging )
            {
                objectChanging = true;
                changeArgs = null;

                if( ObjectChanging != null ) ObjectChanging( this, EventArgs.Empty );
            }
        }

        public void Clear()
        {
            throw new NotImplementedException();
        }

        public BindingList<Variation> CloneVariations()
        {
            BindingList<Variation> clonedVariations = new BindingList<Variation>();

            for( int i = 0; i < variations.Count; i++ ) clonedVariations.Add( variations[i].Clone() );

            return clonedVariations;
        }

        public IProjectItem CreateSubItem( Arguments argumets )
        {
            throw new NotImplementedException();
        }

        public void EndChange( bool discardEvent )
        {
            if( objectChanging )
            {
                objectChanging = false;

                if( !discardEvent && changeArgs != null ) ObjectChangedEvent( this, changeArgs ); 
            }
        }

        public Delegate[] GetReferences()
        {
            return ObjectChanged.GetInvocationList();
        }

        public int IndexOf( IProjectItem item )
        {
            throw new NotImplementedException();
        }

        public int IndexOf( IProjectItem item, int startIndex )
        {
            throw new NotImplementedException();
        }

        public void Insert( int index, IProjectItem item )
        {
            throw new NotImplementedException();
        }

        public void InsertRange( int index, IProjectItem[] items )
        {
            throw new NotImplementedException();
        }

        public bool Load( Arguments arguments )
        {
            throw new NotImplementedException();
        }

        public bool Remove( IProjectItem item )
        {
            throw new NotImplementedException();
        }

        public void RemoveAt( int index)
        {
            throw new NotImplementedException();
        }

        public void RemoveRange( int index, int length )
        {
            throw new NotImplementedException();
        }

        public bool Save( Arguments arguments )
        {
            throw new NotImplementedException();
        }

        public override string ToString()
        {
            return Text;
        }

        private void ObjectChangedEvent( object sender, EventArgs eventArgs )
        {
            if( objectChanging ) 
            {
                changeArgs = eventArgs;
                return;
            }

            if( ObjectChanged != null ) ObjectChanged( sender, eventArgs );
        }
    }
}
