﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Editor.Text
{
    public sealed class CharacterGlyph : Glyph
    {
        private char character;

        public override int CharacterLength 
        {
            get { return 1; }
        }

        public override bool StyleChanging
        {
            get { return true; }
        }

        public override bool StyleCopying
        {
            get { return true; }
        }

        public override EGlyphType Type
        {
            get { return EGlyphType.Character; }
        }

        public CharacterGlyph( char character )
        {
            this.character = character;
            style = (short)EDefaultStyles.Normal;
        }

        public CharacterGlyph( char character, short style )
        {
            this.character = character;
            this.style = style;
        }

        public override Glyph Clone()
        {
            return new CharacterGlyph( character);
        }

        public override string ToString()
        {
            return character.ToString();
        }

        public override char GetCharAt( int index )
        {
            if( index == 0 ) return character;
            else throw new ArgumentOutOfRangeException("index");
        }
    }
}
