﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Editor.Text
{
    public abstract class Glyph : ICloneable<Glyph>, ITypeable<EGlyphType>
    {
        protected short style;

        public short Style
        {
            get { return style; }
            set 
            {
                if( StyleChanging ) style = value;
            }
        }

        public abstract int CharacterLength { get; }
        public abstract bool StyleChanging { get; }
        public abstract bool StyleCopying { get; }
        public abstract EGlyphType Type { get; }

        public abstract Glyph Clone();
        public abstract char GetCharAt( int index );
        
    }
}
