﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Editor.Text
{
    public sealed class UrlGlyph : Glyph, IChangeHandler
    {
        private string url;

        public bool Changing
        {
            get { throw new NotImplementedException(); }
        }

        public override int CharacterLength
        {
            get { return url.Length; }
        }

        public override bool StyleChanging
        {
            get { return false; }
        }

        public override bool StyleCopying
        {
            get { return false; }
        }

        public override EGlyphType Type
        {
            get { return EGlyphType.Url; }
        }

        public string Url
        {
            get { return url; }
            set 
            { 
                if( !string.Equals( url, value ) )
                { 
                    url = value;

                    if( ObjectChanged != null ) ObjectChanged( this, EventArgs.Empty );
                }
            }
        }

        public event EventHandler ObjectChanged;
        public event EventHandler ObjectChanging;

        public UrlGlyph( string url ) 
        {
            this.url = url;
            style = (short)EDefaultStyles.Url;
        }

        public void BeginChange()
        {
            throw new NotImplementedException();
        }

        public override Glyph Clone()
        {
            return new UrlGlyph( url );
        }

        public void EndChange( bool discardEvent )
        {
            throw new NotImplementedException();
        }

        public Delegate[] GetReferences()
        {
            return ObjectChanged.GetInvocationList();
        }

        public override char GetCharAt( int index )
        {
            return url[index];
        }
    }
}
