﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using Editor.Text;

namespace Editor.View
{
    public interface ISegment
    {
        int EndIndex { get; }
        int Length { get; }
        int StartIndex { get; }
        int Indent { get; }
        IStyle Style { get; }
        int Width { get; }

        void Draw( int offset, bool selected, int selectionAscent, int selectionDescent );
        void Draw( int offset, int selectionStart, int selectionEnd,
            int selectionAscent, int selectionDescent );
        int GetSelectionIndex( int x );
        Size Measure( int index, int length );
    }
}
