﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Editor.Text;
using System.Drawing;

namespace UseCaseTool.Controls
{
    public sealed class StyleButton : Button
    {
        private short index;
        private IStyle style;

        public IStyle Style
        {
            get { return style; }
        }

        public short Index
        {
            get { return index; }
        }

        public StyleButton( IStyle style, short index ) : base()
        {
            this.index = index;
            this.style = style;

            Font = new Font( style.FontFamily, 12, style.Font.Style );
            BackColor = style.BackColor;
            ForeColor = style.TextColor;
            Text = string.Concat( style.Name, " [", style.Size.ToString(), "]");
        }

        public void UpdateStyle()
        {
            Font = new Font( style.FontFamily, 12, style.Font.Style );
            BackColor = style.BackColor;
            ForeColor = style.TextColor;
            Text = string.Concat( style.Name, " [", style.Size.ToString(), "]");
        }
    }
}
