﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Editor.Project;

namespace UseCaseTool.Forms
{
    public partial class UseCaseForm : Form
    {
        private UseCase useCase;

        public UseCase UseCase
        {
            get { return useCase; }
        }

        public UseCaseForm( UseCase useCase )
        {
            this.useCase = useCase;

            InitializeComponent();

            nameTB.Text = useCase.ItemName;
        }

        private void confirmBN_Click(object sender, EventArgs e)
        {
            if( nameTB.Text.Trim() == string.Empty )
            {
                MessageBox.Show( "Name cannot be empty", "Warning", MessageBoxButtons.OK, 
                    MessageBoxIcon.Warning );
                return;
            }

            useCase.ItemName = nameTB.Text.Trim();

            DialogResult = DialogResult.OK;
        }
    }
}
