﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Editor.Project;

namespace UseCaseTool.Forms
{
    public partial class VariationsEditorForm : Form
    {
        private BindingList<Variation> variations;

        public BindingList<Variation> Variations
        {
            get { return variations; }
        }

        public VariationsEditorForm()
        {
            InitializeComponent();
        }

        public VariationsEditorForm( BindingList<Variation> variations )
        {
            InitializeComponent();

            this.variations = variations;
            variationsLB.DataSource = variations;
        }

        private void changeVariationBN_Click(object sender, EventArgs e)
        {
            if( variationsLB.SelectedIndex < 0 ) return;

            Variation variation = (Variation)variationsLB.SelectedItem;

            if( variation != null )
            {
                variation.Normal = variationTB.Text.Trim();

                variationTB.Text = string.Empty;
            }    
        }

        private void resetVariationBN_Click(object sender, EventArgs e)
        {
            if( variationsLB.SelectedIndex < 0 ) return;

            Variation variation = (Variation)variationsLB.SelectedItem;

            if( variation != null )
            {
                variation.Normal = string.Empty;

                variationTB.Text = string.Empty;
            }    
        }

        private void variationsLB_SelectedIndexChanged(object sender, EventArgs e)
        {
            if( variationsLB.SelectedIndex < 0 ) return;

            Variation variation = (Variation)variationsLB.SelectedItem;

            if( variation != null )
            {
                if( variation.Defined ) variationTB.Text = variation.Normal;
                else variationTB.Text = string.Empty;
            }    
        }

        private void confirmBN_Click(object sender, EventArgs e)
        {

        }
    }
}
